@if "%ECHO_MODE%"=="" set ECHO_MODE=off
@echo %ECHO_MODE%
setlocal
@rem 2015-10-15  HaSchm: Adapted for MS-VS 2013 Express
@rem 2015-01-08  HaSchm: Initial revision for "*.sln" with MS-VS 2013 = 12.0

@rem Check env. variable needed to find VS
if "%VS120INSTALLDIR%"=="" (
  @echo ?%~nx0: Env. var. [VS120INSTALLDIR] not set [start corresponding Set*Env.bat]
  goto errlevelp
)

@rem Check if VS-exe found
set _goMSVS_exe=
if exist "%VS120INSTALLDIR%\Common7\IDE\devenv.exe" (
  set _goMSVS_exe=devenv.exe
) else if exist "%VS120INSTALLDIR%\Common7\IDE\WDExpress.exe" (
  set _goMSVS_exe=WDExpress.exe
) else (
  @echo ?%~nx0: Wrong env. var. [VS120COMNTOOLS]: "%VS120INSTALLDIR%\Common7\IDE\devenv.exe" and "WDExpress.exe" not found
  goto errlevelp
)

@rem Start VS with (first) found project "*.sln"
for %%N in ("%~dp0.\*.sln") do (
  start "" /B "%VS120INSTALLDIR%\Common7\IDE\%_goMSVS_exe%" "%%~fN"
  @echo %~nx0: MS-VS started for "%%~nxN" ...
  ping -n 6 127.0.0.1 >nul 2>&1
  exit /b 0
)
@echo ?%~nx0: No "*.sln" found
:errlevelp
pause
exit /b 1
:eof
