/*!***************************************************************************

\file wrn_inc.h
\brief <b>Warnungen fr allgemeine Include-Dateien einstellen</b>

\copyright (c) 2000-2015 BSK Datentechnik GmbH

\author Hans Schmidts

$Revision: 1.11 $
$Date: 2015/07/17 16:10:05 $
$Source: /BSK/C/include/wrn_inc.h,v $

*//***************************************************************************

History:
V1.11  2015-07-17  BSK/HS
- Doxygen header
- Kommentare mit Umlauten usw. und Tippfehler korrigiert
V1.10  2009-01-25  BSK/HS
- disable warnings 4097 and 4127
V1.9  2008-08-13  BSK/NU
- removed disabling warnings 4097 and 4127
V1.8  2006-09-06  BSK/NU
- disable:4097 4127 for h added
V1.7  2006-02-10  BSK/HS
- disable:4146 4244 for h added
V1.6  2005-12-09  BSK/HS
- disable:4244 4710 4711 for h and c
- disable:4786 for h and c added
- disable:4245 4511 4512 for h added
V1.5  2002-08-12..2000-07-07  see CVS
*/
#define _WRN_INC_H


/* Bei Microsoft kommen Warnungen sogar aus den standard Header-Files :[! */
#if (defined _MSC_VER) && (_MSC_VER>=1200) /* Ab MSVS 6.0=Compiler 12.00 */
  /* Warnungen die generell abgeschaltet sein mssen: */
  #pragma warning(disable:4244) /* mglicher Datenverlust (kommt blderweise
                                   auch bei z.B. word+=.. und word++) */
  #pragma warning(disable:4710) /* function '...' not inlined */
  #pragma warning(disable:4711) /* function '...' selected for automatic
                                   inline expansion */
  #pragma warning(disable:4786) /* identifier was truncated to 'number'
                                   characters in the debug information */

  /* aktuelle Einstellungen speichern */
  #ifndef _WRN_PUSH
    #define _WRN_PUSH
    #pragma warning(push)
  #endif
  /* Warnungen die nur fr Include-(h-)Dateien abgeschaltet sein mssen: */
  #pragma warning(disable:4001) /* C++-Kommentar */
  #pragma warning(disable:4018) /* signed/unsigned mismatch (*) */
  #pragma warning(disable:4097) /* typedef-name used as synonym for class-name
                                   (message is from MSDN, but seems wrong) */
  #pragma warning(disable:4100) /* unreferenced formal parameter
                                   (e.g. in inline functions in wcealt.h) */
  #pragma warning(disable:4115) /* Benannte Typdefinition in runden Klammern */
  #pragma warning(disable:4121) /* Ausrichtung eines Elements hngt vom
                                   Pragma 'pack' ab (kommt z.B. bei Einst.
                                   des Alignment auf 2 aus winsock.h!?) */
  #pragma warning(disable:4127) /* conditional expression is constant */
  #pragma warning(disable:4201) /* nonstd: nameless struct/union */
  #pragma warning(disable:4146) /* unary minus operator applied to unsigned
                                   type, result still unsigned (*) */
  #pragma warning(disable:4214) /* nonstd: bit field types other than int */
  #pragma warning(disable:4244) /* conversion from 'type1' to 'type2', possible
                                   loss of data (*) */
  #pragma warning(disable:4245) /* conversion from 'type1' to 'type2', signed/
                                   unsigned mismatch (*) */
  #pragma warning(disable:4511) /* copy constructor could not be generated */
  #pragma warning(disable:4512) /* assignment operator could not be generated */
  #pragma warning(disable:4663) /* C++ language change (*) */
  #pragma warning(disable:4665) /* C++ language change (*) */
  /* (*) Need modified VC98\Include\YVALS.H to work. Replace the two
         #pragam warning() with one #pragma warning(4: 4114) */
#elif defined __TURBOC__
  #pragma warn -nak             /* suppress "Non-ANSI keyword"-warning */
#endif

/* EOF wrn_inc.h */
